;-------------------------------------------------------------------
;AppendOrInsert Procedure
;-Adds an entry to a Linked-List...
;-Allocates memory for a new entry,
;-Examines Parent<--->Child links and
;-Patches- Parent<--<THIS>-->Child (Inserting Self).
;-Bidirection links are preserved.
;-------------------------------------------------------------------
AppendOrInsert PROC lpParent:LPLINKEDOBJECT , ObjectSize:DWORD
LOCAL lpOldChild:PTR LINKEDOBJECT
LOCAL hMem:DWORD
local ERRbuff[256]:BYTE
    push edi
    push esi
    mov esi, lpParent    
    mov hMem,$invoke (GlobalAlloc,GMEM_MOVEABLE,ObjectSize)
    .if eax != NULL       
        mov edi, $invoke (GlobalLock,hMem)
        .if edi != NULL
            assume edi:ptr LinkedObject 
            m2m [edi].hLock, hMem                         ;(Remember my unlock handle)
            .if esi != NULL                                   ;if I have a Parent (and thus am not Root)            
                assume esi:ptr LinkedObject 
                m2m lpOldChild, [esi].pChild    ;store POSSIBLE previous child of Parent
                mov [esi].pChild, edi                ;Parent's Child = Myself
                mov [edi].pParent, esi             ;Myself's Parent = Parent
                mov eax, lpOldChild
                .if eax != NULL                               ;and that Parent already had a Child - WE ARE INSERTING!
                    mov esi, lpOldChild
                    mov [esi].pParent, edi       ;OLD Child's Parent = Myself
                    mov [edi].pChild, esi         ;Myself's Child = Parent's OLD Child
                .else
                    mov [edi].pChild, NULL      ;Myself's Child = NONE (since we are not inserting, we are APPENDING)
                .endif

            .else                                                ;elseif I am Root (with No Parent,  and No Child (since I'm new) )
                mov [edi].pParent, NULL
                mov [edi].pChild, NULL
            .endif
            ;==========================================
            ;Null-out Application-Specific fields to prevent errors
            mov [edi].pName, NULL
            mov [edi].hNameLock, NULL
            mov [edi].pOlderSibling,NULL
            mov [edi].pYoungerSibling,NULL
            ;==========================================
            mov eax, edi
            pop esi
            pop edi
            return eax                                        ;Return pointer to the new Object in EAX
        .else                                                 ;GlobalLock failed...
            invoke GetLastError
            invoke wsprintf,addr ERRbuff,CTXT("GlobalLock err #%lu"),eax
            invoke MessageBox,NULL, addr ERRbuff,CTXT("Error!"),MB_OK+MB_ICONERROR
            invoke GlobalFree,hMem                            ;Free the memory we Failed to Lock
        .endif
    .else                                                     ;GlobalAlloc failed...
        invoke GetLastError
        invoke wsprintf,addr ERRbuff,CTXT("GlobalAlloc err #%lu"),eax
        invoke MessageBox,NULL,addr ERRbuff,CTXT("Error!"),MB_OK+MB_ICONERROR
    .endif

    pop esi
    pop edi
    xor eax,eax
    ret                                                       ;Return ERROR in eax since we have Failed

AppendOrInsert ENDP