; #########################################################################
.code
KillName PROC lpThis:PTR LINKEDOBJECT
    .if lpThis==0
        return FALSE
    .endif
    push edi
    mov edi, lpThis
    assume edi:LPLINKEDOBJECT
    .if [edi].hNameLock != NULL                  ;Make sure I have a Name to Release
        invoke GlobalUnlock,[edi].hNameLock         ;Unlock the Name memory
        invoke GlobalFree,[edi].pName     ;Free the Name memory
        ;-------------------------------
        ;Null-out Name fields
        ;-------------------------------
        mov [edi].pName, NULL
        mov [edi].hNameLock, NULL
    .endif
    assume edi:nothing
    pop edi
    return TRUE
KillName  ENDP

;#########################################################################

NewName PROC lpThis:PTR LINKEDOBJECT, pszNewName:DWORD
local ERRbuff[256]:BYTE
    .if pszNewName==NULL || lpThis==NULL
        return NULL
    .endif
    push edi
    push esi
    mov edi, lpThis
    invoke lstrlen, pszNewName
    inc eax                                                 ;add a byte to hold the zero terminator
    invoke GlobalAlloc,GPTR,eax                               ;Allocate memory for name
    assume edi:ptr LinkedObject
    mov LinkedObject [edi].hNameLock, eax                     ;Remember the unlock handle
    .if eax != NULL
        invoke GlobalLock, eax
        mov [edi].pName, eax
        .if eax != NULL
            assume edi:LPLINKEDOBJECT
            invoke lstrcpy, [edi].pName, pszNewName          ;copy the string into the allocated memory
            assume edi:nothing
            mov eax, lpThis                                                    ;Return the object pointer back to the caller
            pop esi
            pop edi
            return eax                                        ;Return pointer to the new Object in EAX
        .else                                                 ;GlobalLock failed...
            push $invoke (GetLastError)
            assume edi:LPLINKEDOBJECT
            invoke GlobalFree,[edi].hNameLock          ;Free the memory we Failed to Lock
            mov LinkedObject [edi].hNameLock, NULL
            pop eax
            invoke wsprintf,addr ERRbuff,CTXT("GlobalLock err #%lu"),eax
            invoke MessageBox,NULL, addr ERRbuff,CTXT("Error!"),MB_OK+MB_ICONERROR
        .endif
    .else                                                     ;GlobalAlloc failed...
        invoke GetLastError
        invoke wsprintf,addr ERRbuff,CTXT("GlobalAlloc err #%lu"),eax
        invoke MessageBox,NULL,addr ERRbuff,CTXT("Error!"),MB_OK+MB_ICONERROR
    .endif
    assume edi:nothing
    pop esi
    pop edi
    xor eax,eax
    ret                                                       ;Return ERROR in eax since we have Failed
NewName ENDP