
_saferender MACRO Fun:REQ
    .if Fun != 0
        mcall [Fun],ID3DXMesh_DrawSubset, 0
    .endif
ENDM




_saferendertexmesh MACRO Fun:REQ
    .if Fun != 0
        mov esi,Fun
        assume esi:ptr Object
    ; Meshes are divided into subsets, one for each material. Render them in a loop !!!
 ;       mcall [lpd3dDevice],IDirect3DDevice8_SetTexture, 0, NULL
        xor ebx,ebx         ;preset ebx to 0 cuz its our "material counter"
        mov edi, [esi].pMeshTextures
        mov ecx,[esi].pMeshMaterials
        .while ebx<[esi].dwNumMaterials     
            mcall [lpd3dDevice],IDirect3DDevice8_SetMaterial, ecx
            mcall [lpd3dDevice],IDirect3DDevice8_SetTexture, 0, [edi]
            mov eax, [esi].pMesh
            mcall eax, ID3DXMesh_DrawSubset, ebx
            add	edi, 4                                                   ;next pTexture
            add ecx,sizeof D3DMATERIAL8                     ;next Material
            inc	ebx             
        .endw
        assume esi:nothing
;        mcall [lpd3dDevice],IDirect3DDevice8_SetTexture, 0, NULL
    .endif
endm



;------------------------------------------------------------------------------------------------------------
; SAFERELEASE - Releases COM Interfaces and Objects
; Tests an Interface Pointer is nonzero, if so calls IUnknown_Release on it.
;----------------------------------------------------------------------------------------------------------------
_saferelease MACRO Fun:REQ
    .if Fun != 0
        mcall [Fun], IUnknown_Release
        mov dword ptr [Fun], NULL
    .endif
ENDM


$mcall MACRO Fun:REQ, A:VARARG
  IFB <A>
    mcall Fun
  else
    mcall Fun, A
  endif
  exitm <eax>
ENDM


;-----------------------------------------------------------------------------------------------------------------------------------
; BEGIN_INTERFACE starts a COM Interface definition
; Used in includes.
; sets equate ??Interface. 
;-----------------------------------------------------------------------------------------------------------------------------------
; Note: this macro defines ??Interface and  ??Function, so dont use these names
;-----------------------------------------------------------------------------------------------------------------------------------

BEGIN_INTERFACE macro name, inheritedfrom
??Interface equ <name>
&name&Vtbl struct
ifnb <inheritedfrom>
inheritedfrom&Vtbl <>
endif
endm

;-----------------------------------------------------------------------------------------------------------------------------------
; END_INTERFACE finishes current interface definition
; Used in includes. clears equate ??Interface
;-----------------------------------------------------------------------------------------------------------------------------------

END_INTERFACE macro

%??Interface&Vtbl ends
%p&??Interface&Vtbl typedef ptr ??Interface&Vtbl

??Interface struct
%pVtbl p&??Interface&Vtbl ?
??Interface ends

??Interface equ <>
endm
;-----------------------------------------------------------------------------------------------------------------------------------
DECLARE_INTERFACE MACRO ifacename
ifacename typedef DWORD
CurrInterfaceName TEXTEQU <ifacename>
ifaceMethodVirtualOffset=0
ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
STDMETHOD MACRO MethodName:REQ,Args:VARARG
 CurrMethodName CATSTR  CurrInterfaceName,<MethodName>
 CurrMethodProto CATSTR CurrMethodName,<Proto>
 CurrMethodProto typedef PROTO Args
 CurrMethodName = ifaceMethodVirtualOffset
 ;* Advance to the next position in vtable
 ifaceMethodVirtualOffset=ifaceMethodVirtualOffset+sizeof(LPVOID)
 ;;%ECHO &CurrMethodName
ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
 ; Define IUnknown interface, which is common for all objects
DECLARE_INTERFACE <IUnknown_>
;  /*** IUnknown methods ***/
    STDMETHOD <QueryInterface>,:PTR,:PTR PTR
    STDMETHOD <AddRef>
    STDMETHOD <Release>
;-----------------------------------------------------------------------------------------------------------------------------------
INHERIT_IUnknown MACRO
  STDMETHOD <QueryInterface>,:PTR,:PTR PTR
  STDMETHOD <AddRef>
  STDMETHOD <Release>
ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
$invoke MACRO Fun:REQ, A:VARARG
  IFB <A>
    invoke Fun
  else
    invoke Fun, A
  endif
  exitm <eax>
ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
return MACRO ralf:REQ
mov eax,ralf
ret
ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
;*****************************************************************************
;*      Macro to call COM-object methods. Type checking is performed.        *
;*****************************************************************************
mcall MACRO ObjPtr:REQ,MethodName:REQ,Args:VARARG
CurrMethodProto CATSTR <MethodName>,<Proto>
IFNB <Args>
  mcallDanger=0
  mcallNumArgs=0
  IFIDNI <ObjPtr>,<[eax]>
   Check_mcallArgs Args
  ENDIF
   IF mcallDanger
   echo Warning: Dangerous mcall!
   push [eax]     ; save ObjPtr
   invoke CurrMethodProto ptr [eax],Args
   ORG $-2
   mov eax,[esp+mcallNumArgs*4]
   push eax       ; this
   mov eax,[eax]  ; vtable*
   call dword ptr [eax+MethodName]
   add esp,4      ; clean up stack
  ELSE
     invoke CurrMethodProto ptr [eax],Args
   ORG $-2
   mov edx,edx    ; filler!
   mov eax,ObjPtr
   push eax       ; this
   mov eax,[eax]  ; vtable*
   call dword ptr [eax+MethodName]
  ENDIF
ELSE ;----- No args
  mov eax,ObjPtr
  push eax       ; this
  mov eax,[eax]  ; vtable*
  invoke CurrMethodProto ptr [eax+MethodName]
ENDIF
ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      return MACRO arg
        mov eax, arg
        ret
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      stralloc MACRO ln
        invoke SysAllocStringByteLen,0,ln
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      strfree MACRO strhandle
        invoke SysFreeString,strhandle
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
    ; -------------------------
    ; initialised GLOBAL value
    ; -------------------------
      IGLOBAL MACRO variable:VARARG
      .data
        variable
      .code
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
    ; --------------------------------
    ; initialised GLOBAL string value
    ; --------------------------------
      STRING MACRO variable:REQ,args:VARARG
      .data
        variable db args,0
      .code
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
    ; ---------------------
    ; literal string MACRO
    ; ---------------------
      literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
      SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
    ; --------------------------------
    ; string OFFSET for manual coding
    ; --------------------------------
      CTXT MACRO quoted_text:VARARG
        EXITM <offset literal(quoted_text)>
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      ShellAboutBox MACRO handle,IconHandle,quoted_Text_1,quoted_Text_2:VARARG
        LOCAL AboutTitle,AboutMsg,buffer
          .data
            AboutTitle db quoted_Text_1,0
            AboutMsg   db quoted_Text_2,0
            buffer db 128 dup (0)
          .code
        mov esi, offset AboutTitle
        mov edi, offset buffer
        mov ecx, lengthof AboutTitle
        rep movsb
        invoke ShellAbout,handle,ADDR buffer,ADDR AboutMsg,IconHandle
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      AppModel MACRO Processor
        Processor             ;; Processor type
        .model flat, stdcall  ;; 32 bit memory model
        option casemap :none  ;; case sensitive
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      DisplayWindow MACRO handl, ShowStyle
        invoke ShowWindow,handl, ShowStyle
        invoke UpdateWindow,handl
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      AutoScale MACRO swidth, sheight        
        mov Wwd, $invoke (GetPercent,sWid,swidth)        
        mov Wht,   $invoke (GetPercent,sHgt,sheight)
        mov Wtx, $invoke (TopXY,Wwd,sWid)
        mov Wty, $invoke (TopXY,Wht,sHgt)
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
      SingleInstanceOnly MACRO lpClassName
        invoke FindWindow,lpClassName,NULL
        cmp eax, 0
        je @F
          push eax
          invoke ShowWindow,eax,SW_RESTORE
          pop eax
          invoke SetForegroundWindow,eax
          mov eax, 0
          ret
        @@:
      ENDM
;-----------------------------------------------------------------------------------------------------------------------------------
StackSafeA macro
    push 12345678
    endm
StackSafeB macro
    pop eax
    .if eax!=12345678
        invoke MessageBox,0,CTXT("StackFuck"),CTXT("!!!!!"),MB_OK+MB_ICONERROR
    .endif
    endm